##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (sampledir)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config/include file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for Cloud

%define name		ksm-cloud
%define version		0.0.6
%define release		2.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs to use a cloud
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Networking/File-Sharing
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	rsync
Requires:	ksm-lib-sh >= 5.0.1-0.0.0
#Provides:	sampled
#Conflicts:	sampled-other,libsample == 0.0.0
#Obsoletes:	mysampled

%description
This package contains programs to use a cloud. Read the file cloud-help.txt.

Please check/configure:
 /usr/local/etc/cloud.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
%attr(644,root,root)%{_confdir}/cloud.conf
#%attr(644,root,root)%{_scnfdir}/sample

#%attr(744,root,root)%{_rcdir}/sampled
#%attr(777,root,root)%{_bindir}/rcsampled
%attr(755,root,root)%{_bindir}/clouddnsync
%attr(755,root,root)%{_bindir}/cloudupsync
%attr(755,root,root)%{_bindir}/update-cloud

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/cloudrc.templ

/usr/share/applications/clouddnsync.desktop
/usr/share/applications/cloudupsync.desktop
%{_icondir}/16x16/apps/cloud-dnsync.png
%{_icondir}/16x16/apps/cloud-upsync.png
%{_icondir}/22x22/apps/cloud-dnsync.png
%{_icondir}/22x22/apps/cloud-upsync.png
%{_icondir}/32x32/apps/cloud-dnsync.png
%{_icondir}/32x32/apps/cloud-upsync.png
%{_icondir}/48x48/apps/cloud-dnsync.png
%{_icondir}/48x48/apps/cloud-upsync.png
%{_icondir}/64x64/apps/cloud-dnsync.png
%{_icondir}/64x64/apps/cloud-upsync.png
%{_icondir}/128x128/apps/cloud-dnsync.png
%{_icondir}/128x128/apps/cloud-upsync.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/clouddnsync.1.gz
%{_man1dir}/cloudupsync.1.gz
%{_man1dir}/update-cloud.1.gz

#%docdir %{_man8dir}
#%{_man8dir}/sampled.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de
%{_docdir}/cloud-help.txt

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# create group and user
#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
test -e %{_confdir}/cloud.conf && cp %{_confdir}/cloud.conf %{_confdir}/cloud.conf.rpmsave
#test -e %{_scnfdir}/cloud && cp %{_scnfdir}/cloud %{_scnfdir}/cloud.rpmsave

# disable cloud daemon and stop clouddm
#test -x %{_bindir}/togglecloud && %{_bindir}/togglecloud -d -q > /dev/null 2>&1
#test -x %{_rcdir}/clouddm && %{_rcdir}/clouddm stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
xdg-desktop-menu uninstall \
	/usr/share/applications/clouddnsync.desktop \
	/usr/share/applications/cloudupsync.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall cloudname
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/clouddm.service ]; then
#		systemctl stop clouddm.service
#		systemctl disable clouddm.service
#		rm %{_sysddir}/clouddm.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	if [ -e %{_rcdir}/clouddm ]; then
#		test -x %{_rcdir}/clouddm && %{_rcdir}/clouddm stop > /dev/null 2>&1
#		insserv -r clouddm > /dev/null 2>&1
#		rm -f %{_rcdir}/clouddm
#		rm -f %{_sbindir}/rcclouddm
#	fi
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# Definition of vars
# set config pathname. config file needs a version at first cnfvar!
cf=%{_confdir}/cloud.conf
cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
f='' templ='' tmpf='' flag=''
ret=0
#
#incf=%{_confdir}/cloud.incl

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable cloud daemon
#test -x %{_bindir}/togglecloud && %{_bindir}/togglecloud -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# handle include files
#if [ -e "$incf" ]; then
#	rm $incf.rpmnew
#else
#	mv $incf.rpmnew $incf
#	echo "Check $incf"
#fi

# install desktop files
xdg-desktop-menu install --novendor \
	/usr/share/applications/clouddnsync.desktop \
	/usr/share/applications/cloudupsync.desktop

# INIT SCRIPT/SYSTEMD UNIT - install cloudname
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/clouddm.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable clouddm.service
#	echo "clouddm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start clouddm within yast or manual with:"
#	echo "systemctl start clouddm.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/clouddm.rc %{_rcdir}/clouddm
#	ln -sf %{_rcdir}/clouddm %{_sbindir}/rcclouddm
#	insserv clouddm > /dev/null 2>&1
#	echo "clouddm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start clouddm within yast or manual with rcclouddm start"
#fi

# install/update all users rc files
#updcmd='' usr='' u=''
#updcmd="%{_bindir}/update-cloud -q"
# for all usr below /home/ do:
#usr=$(/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1)
#for u in $usr; do
#	if [ -e /home/${u}/.cloudrc ]; then	# if exist rc file
#		/bin/su $u -c "$updcmd"
#	fi
#done
#echo "Package ksm-cloud: All users rc files have been updated"
#echo "Package ksm-cloud: All existing users rc files have been updated"

if [ "$1" == 1 ]; then					# install package
	echo "Configure $cf"
else							# upgrade package
	# update global conf
	if [ -e $cf.rpmsave ]; then
		c='' s='' t=''
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave

		# update conf vars START -------------------------------------
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Packag $clouddir: Error - cmd replcnfvar not found or not executable!" >&2
			echo "Packag $clouddir: Conf file not updated!" >&2
		fi
		# update conf vars STOP --------------------------------------

		# update array vars START ------------------------------------
		cnt=${#ModData[@]}				# max index of array
		i=0
		if [ "$cnt" -gt 0 ]; then
			while [ "$i" -lt $cnt ]; do
				let i++
				# array ModData
				s="ModData[$i]=\"${ModData[$i]}\""
				echo "$s" >> $cf		# append to conf file
				# array DirData
				s="DirData[$i]=\"${DirData[$i]}\""
				echo "$s" >> $cf		# append to conf file
				# array UpSync
				s="UpSync[$i]=\"${UpSync[$i]}\""
				echo "$s" >> $cf		# append to conf file
				# array UpDelete
				s="UpDelete[$i]=\"${UpDelete[$i]}\""
				echo "$s" >> $cf		# append to conf file
				# array DnDelete
				s="DnDelete[$i]=\"${DnDelete[$i]}\""
				echo "$s" >> $cf		# append to conf file
			done
		fi
		# update array vars STOP -------------------------------------

		# compare new conf vars <--> old conf vars
		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi
fi
# if libraries contained:
#ldconfig
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#f='' tmpf='' flag=''
#ret=0

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/cloudconf.conf && cp %{_confdir}/cloudconf.conf %{_confdir}/cloudconf.conf.rpmsave
	#test -e %{_scnfdir}/cloudconf && cp %{_scnfdir}/cloudconf %{_scnfdir}/cloudconf.rpmsave

	# disable cloud daemon and stop clouddm
	#test -x %{_bindir}/togglecloud && %{_bindir}/togglecloud -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/clouddm && %{_rcdir}/clouddm stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	xdg-desktop-menu uninstall \
		/usr/share/applications/clouddnsync.desktop \
		/usr/share/applications/cloudupsync.desktop

	# remove entries from file cloud
	#f=/.../cloud					# pathname of file
	#tmpf=/tmp/cloud				# tempfile
	#flag=clouddir					# flag for entries
	#ret=0
	#if [ -e $f ]; then
	#	grep -q $flag $f			# look for flag
	#	ret=$?
	#	if [ $ret -eq 0 ]; then			# flag found
	#		cat $f | grep -v $flag > $tmpf	# rm add from file
	#		cp $tmpf $f
	#		rm -f $tmpf
	#	fi
	#else
	#	echo "Packag $clouddir: File $f not found!"
	#fi

	# INIT SCRIPT/SYSTEMD UNIT - uninstall cloudname
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/clouddm.service ]; then
	#		systemctl stop clouddm.service
	#		systemctl disable clouddm.service
	#		rm %{_sysddir}/clouddm.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#		test -x %{_rcdir}/clouddm && %{_rcdir}/clouddm stop > /dev/null 2>&1
	#		insserv -r clouddm > /dev/null 2>&1
	#		rm -f %{_rcdir}/clouddm
	#		rm -f %{_sbindir}/rcclouddm
	#	fi
	#fi
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/clouddir
#else							# upgrade package
fi
exit 0

%changelog
* Fri Mar 24 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.6-2.0.0
- The RPM scriptlets have been revised/improved.

* Thu Mar 23 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.6-1.0.0
- The RPM scriptlets have been revised/improved.

* Wed Feb 01 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.6-0.0.0
- All scripts have been revised.
- Added optional config local.

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.5-1.0.0
- Update to the libfuncstd-sh 4.0.0

* Sun Jan 22 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.5-0.2.0
- All scripts have been revised/improved
  (using function GetOpt).

* Thu Nov 10 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.5-0.1.0
- The scripts clouddnsync, cloudupsync and
  update-cloud have been revised.

* Sat Mar 14 2015 Repomaster <repomaster@kaesmann-online.de> 0.0.5-0.0.0
- The config file has changed.
- The scripts clouddnsync and cloudupsync
  have been revised.

* Wed Feb 04 2015 Repomaster <repomaster@kaesmann-online.de> 0.0.4-0.0.0
- The scripts have been revised.
- The config file has changed.

* Tue Feb 03 2015 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.1.0
- The scripts have been revised.

* Wed Oct 01 2014 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.0.4
- The docu of the package has been revised.

* Wed Apr 03 2013 Juergen Kaesmann <juergen@kaesmann.us> 0.0.3-0.0.3
- The RPM scriptlets have been revised.

* Wed Nov 07 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.3-0.0.2
- The scripts have been revised.

* Mon Oct 15 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.3-0.0.1
- The config file has been revised.

* Sat Oct 13 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.3-0.0.0
- The config file has changed.
- Option -k has been removed - configure the config file to keep
  extraneous data for each module.

* Sat Oct 13 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.5.2
- The icons have been renamed.

* Fri Oct 12 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.5.1
- The icons have been replaced.

* Wed Oct 10 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.5.0
- The RPM scriptlets have been revised.

* Wed Oct 10 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.4.0
- The scripts have been revised.
- Removed the include files.

* Wed Oct 10 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.3.0
- The scripts and the include files have been revised.

* Wed Sep 26 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.2.0
- The package has been revised.

* Tue Jun 05 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.1.0
- The icons have been revised.

* Thu May 31 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.0.1
- The docu has been revised.

* Tue May 29 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.2-0.0.0
- The config file cloud.conf has been revised (different dirs).

* Sat May 26 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.6.2
- The docu has been revised.

* Mon May 21 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.6.1
- The docu has been revised.
- The RPM scriptlets have been revised.

* Mon May 21 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.6.0
- The default config has changed in:
  HOME/Desktop/CloudDnSync.desktop
  HOME/Desktop/CloudUpSync.desktop
- The default config of the cloud host has changed.
- The docu has been revised.

* Thu May 10 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.5.0
- The scripts clouddnsync and cloudupsync has been revised
  (added versioning).
- The config file cloud.conf has been revised (added versioning).
- The docu has been revised.

* Thu May 10 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.4.0
- The scripts clouddnsync and cloudupsync has been revised.
- The config file cloud.conf has changed.

* Wed May 09 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.3.0
- The package config and the docu has been revised.

* Wed May 09 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.2.1
- The docu has been revised.

* Tue May 08 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.2.0
- The config files has been revised.

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.1.0
- The config has changed (only public dirs are allowed).
- The file cloud.pwd has been removed.

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-1.0.0
- Following files has been renamed:
  cloudsync        -> clouddnsync
  cloudupload      -> cloudupsync
  cloudsync.incl   -> clouddnsync.incl
  cloudupload.incl -> cloudupsync.incl

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.1.0
- The package has been revised (Config).

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.0.0
- The package has been revised.

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.0-0.0.0
- First install.
